/* 
 * Copyright (C) 2008 Laird Breyer
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author:   Laird Breyer <laird@lbreyer.com>
 */

#ifndef BOXEDITOR_H
#define BOXEDITOR_H

#include "common.h"
#include "imagebuffer.h"
#include "boxlist.h"
#include "xtwin.h"

typedef struct {
  boxlist_t *bl;
  imagebuffer_t *ib;
  struct display_state *ds;
  xtwin_t xtw;
  bool_t dirty_list;
  bool_t dirty_graph;
  int speed_edit;
} boxeditor_t;

typedef struct display_state {
  int num_rows;
  int num_cols;
  bool_t delay_sigwinch;
  int highlighted;
  int first_visible;
  char *fkey_cmd[10];
  boxeditor_t *ed;
} display_state_t;

void init_boxeditor(int *argc, char ***argv); 

bool_t create_boxeditor(boxeditor_t *e, imagebuffer_t *ib, boxlist_t *bl);
bool_t free_boxeditor(boxeditor_t *e);

bool_t run_boxeditor(boxeditor_t *e);
void redraw_boxeditor(boxeditor_t *e);
bool_t gotoxy_boxeditor(boxeditor_t *e, long int x, long int y);

#endif
