/* 
 * Copyright (C) 2008 Laird Breyer
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author:   Laird Breyer <laird@lbreyer.com>
 */

#ifndef XTWIN_H
#define XTWIN_H

#include "common.h"
#include "boxlist.h"
#include "imagebuffer.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>

typedef struct {
  Display *dpy;
  Visual *vis;
  int scr;
  int depth;
  int bytespp;
  int scanline_pad;
  Window win;
  XImage *xim;
  char *sbuf;
  int xsize;
  int ysize;
  int maxwidth;
  int maxheight;
} xtwin_t;

typedef enum { NO_EVENTS = 0, NULL_EVENT, READY_EVENT} xtwin_event_t;

bool_t create_xtwin(xtwin_t *w, int maxwidth, int maxheight);
bool_t free_xtwin(xtwin_t *w);
xtwin_event_t next_event_xtwin(xtwin_t *w);
bool_t alloc_image_xtwin(xtwin_t *w);
bool_t sync_xtwin(xtwin_t *w);
bool_t redraw_xtwin(xtwin_t *w, imagebuffer_t *ib, box_t *box);


#endif
